/* Copyright (c) 2001-2009 by SoftIntegration, Inc. All Rights Reserved */
/* file name: list.h */
#ifndef LIST_H_
#define LIST_H_

#include <dlfcn.h>

class List {
    private:
        static int m_dlcount;
        static void *m_dlhandle;
        class List *m_class;

    public:
        List();
        ~List();                //remove memory
        void prepend (int ssn, string_t fname, string_t lname);  
                                //prepend to list at beginning
        void print();           //print out list
        int  remove (int ssn);  //delete first node with ssn=ssn
};

/******************** Static fields ********************/
int List::m_dlcount = 0;
void *List::m_dlhandle = NULL;


/* get member functions of class List*/
#pragma importf <List.chf>

#endif /* LIST_H_ */
